{ 990313V2.PAS                                                              }
{ 1999-03-13 programmeerimisolmpiaadi vanema rhma 2. lesande lahendus    }
{    KIIP                                                                   }
{ Ahto Truu                                                                 }

{$M 65520, 0, 0}                                { 64K magasin - jada prast }

const
   sisf = 'KIIP.SIS';                                    { sisendfaili nimi }
   valf = 'KIIP.VAL';                                   { vljundfaili nimi }
   maxx = 100;                                    { kiibi maksimaalne laius }
   maxy = 100;                                   { kiibi maksimaalne krgus }
   maxa = (maxx + 1) * (maxy + 1);        { maksimaalne jada elementide arv }
   maxd = 8;                            { maksimaalne henduste arv punktil }
   dx : array [1..maxd] of shortint = (1, 1, 0, -1, -1, -1, 0, 1);
   dy : array [1..maxd] of shortint = (0, 1, 1, 1, 0, -1, -1, -1);

type
   solm = record                                          { kiibi vrguslm }
      x, y : shortint;                                 { slme koordinaadid }
   end;
   kiip = record                                          { kiibi kirjeldus }
      x, y : byte;                                          { kiibi mtmed }
      o : array [0..maxx, 0..maxy] of integer;             { slmede olekud }
      d : array [0..maxx, 0..maxy] of byte; { millistes suundades on seosed }
      a, b : solm;                  { puuduva henduse algus- ja lpp-punkt }
      c : solm;                           { esimese lisatud lli alguspunkt }
      p : integer;                               { lisatava henduse pikkus }
   end;
   jada = record                                       { kiibi slmede hulk }
      n : integer;                                     { slmede arv hulgas }
      l, e : integer;                 { lisamis- ja eemaldamiskoha indeksid }
      s : array [1..maxa] of solm;                                 { slmed }
   end;

{ leiab, millisesse suunda slmest s1 jb slm s2 }
{ 1 - paremale, 2 - paremale-les, 3 - les, ..., 8 - paremale-alla }
function suund (s1, s2 : solm) : integer;
var d : integer;
begin
     suund := 0;
     for d := 1 to maxd do
         if (s1.x + dx[d] = s2.x) and (s1.y + dy[d] = s2.y) then
            suund := d;
end;

{ leiab slme s1 naabri suunas d }
procedure leia_naaber (s1 : solm; d : integer; var s2 : solm);
begin
   s2.x := s1.x + dx[d]; s2.y := s1.y + dy[d];
end;

{ kontrollib, kas slm jb kiibi piiridesse }
function kiibil (var k : kiip; s : solm) : boolean;
begin
   kiibil := not ((s.x < 0) or (s.x > k.x) or (s.y < 0) or (s.y > k.y));
end;

{ kontrollib, kas tee slmede s1 ja s2 vahel on vaba }
function vaba (var k : kiip; s1, s2 : solm) : boolean;
var x : integer;
begin
   if (s1.x = s2.x) or (s1.y = s2.y) then
      vaba := true
   else begin
      x := s1.x; s1.x := s2.x; s2.x := x;
      vaba := k.d[s1.x, s1.y] and (1 shl (suund (s1, s2) - 1)) = 0;
   end;
end;

procedure loe_sisend (var k : kiip);
var f : text; n, i : longint; x, y : byte; s1, s2 : solm;
begin
   assign (f, sisf); reset (f);
   readln (f, k.x, k.y, n);
   for x := 0 to k.x do
      for y := 0 to k.y do begin
         k.o[x, y] := 0;
         k.d[x, y] := 0;
      end;
   for i := 1 to n do begin
      readln (f, s1.x, s1.y, s2.x, s2.y);
      k.o[s1.x, s1.y] := -1; k.o[s2.x, s2.y] := -1;
      k.d[s1.x, s1.y] := k.d[s1.x, s1.y] or (1 shl (suund (s1, s2) - 1));
      k.d[s2.x, s2.y] := k.d[s2.x, s2.y] or (1 shl (suund (s2, s1) - 1));
   end;
   readln (f, k.a.x, k.a.y, k.b.x, k.b.y);
   close (f);
end;

{ abifunktsioonid lainefronti esitava jadaga opereerimiseks }
procedure tyhjenda (var a : jada);
begin
   a.n := 0; a.l := 1; a.e := 1;
end;

procedure pane (var a : jada; s : solm);
begin
   a.n := a.n + 1;
   a.s[a.l] := s;
   a.l := a.l mod maxa + 1;
end;

procedure vota (var a : jada; var s : solm);
begin
   a.n := a.n - 1;
   s := a.s[a.e];
   a.e := a.e mod maxa + 1;
end;

{ leiab slme olemasolevad seosed, mrgib seotud slmed mrgendiga m }
procedure leia_seosed (var k : kiip; s : solm; m : integer);
var a : jada; s1, s2 : solm; i, d : integer;
begin
   tyhjenda (a);
   k.o[s.x, s.y] := m;
   pane (a, s);
   while a.n > 0 do begin
      vota (a, s1);
      for d := 1 to maxd do
            { kui s1 on hendus suunas d }
         if k.d[s1.x, s1.y] and (1 shl (d - 1)) > 0 then begin
            leia_naaber (s1, d, s2);
            if k.o[s2.x, s2.y] <> m then begin
               k.o[s2.x, s2.y] := m;
               pane (a, s2);
            end;
      end;
   end;
end;

{ leiab juurdelisatava henduseligu pikkuse }
procedure leia_pikkus (var k : kiip);
var a : jada; s1, s2 : solm; i, d : integer; x, y : byte; f : boolean;
begin
   leia_seosed (k, k.a, -2);         { mrgendame kik Aga hendatud slmed }
   leia_seosed (k, k.b, 1);          { mrgendame kik Bga hendatud slmed }
       { laine algab korraga kigist Bga hendatud slmedest }
   tyhjenda (a);
   for x := 0 to k.x do
      for y := 0 to k.y do
         if k.o[x, y] = 1 then begin
            s1.x := x; s1.y := y; pane (a, s1);
         end;
      { lainetame, kuni juame mne Aga hendatud slmeni }
   f := false;
   while not f and (a.n > 0) do begin
      vota (a, s1);
      for d := 1 to maxd do begin
         leia_naaber (s1, d, s2);
         if kiibil (k, s2) then
            if vaba (k, s1, s2) then
               if k.o[s2.x, s2.y] = 0 then begin
                  k.o[s2.x, s2.y] := k.o[s1.x, s1.y] + 1;
                  pane (a, s2);
               end else if k.o[s2.x, s2.y] = -2 then begin
                  k.c := s2; k.p := k.o[s1.x, s1.y];
                  f := true;
               end;
      end;
   end;
   if not f then
      k.p := -1;
end;

procedure tee_valjund (var k : kiip);
var f : text; s1, s2, sd : solm; p, d : integer;
begin
   assign (f, valf); rewrite (f);
   if k.p < 0 then
      writeln (f, 'EI SAA')
   else begin
      writeln (f, k.p);
      s1 := k.c;
      for p := k.p downto 1 do begin
         for d := 1 to maxd do begin
            leia_naaber (s1, d, sd);
            if kiibil (k, sd) then
               if k.o[sd.x, sd.y] = p then
                  s2 := sd;
         end;
         writeln (f, s1.x, ' ', s1.y, ' ', s2.x, ' ', s2.y);
         s1 := s2;
      end;
   end;
   close (f);
end;

var
   k : kiip;
begin
   loe_sisend (k);
   leia_pikkus (k);
   tee_valjund (k);
end.
