{ 990313V3.PAS                                                              }
{ 1999-03-13 programmeerimisolmpiaadi vanema rhma 3. lesande lahendus    }
{    ASTRONOOMID                                                            }
{ Ahto Truu                                                                 }

const
   sisf = 'ASTRO.SIS';                                   { sisendfaili nimi }
   valf = 'ASTRO.VAL';                                  { vljundfaili nimi }
   maxx = 100;                                   { maksimaalne veergude arv }
   maxy = 100;                                     { maksimaalne ridade arv }
   maxv = maxx * maxy;                   { maksimaalne valgete punktide arv }
   maxr = maxx + maxy;                                { maksimaalne raadius }

type
   punkt = record                                              { pildipunkt }
      x, y : integer;                                        { koordinaadid }
   end;
   pilt = record                                               { pildi info }
      x, y : integer;                                             { mtmed }
      n : integer;                                   { valgete punktide arv }
      v : array [1..maxv] of punkt;                        { valged punktid }
   end;
   ring = record                                               { ringi info }
      x, y : integer;                             { keskpunkti koordinaadid }
      r : integer;                                                { raadius }
      v : longint;                                             { vigade arv }
   end;
   stat = array [0..maxr] of longint;       { raadiustele vastav statistika }

procedure loe_sisend (var p : pilt);
var f : text; x, y : integer; c : char;
begin
   assign (f, sisf); reset (f);
   readln (f, p.x, p.y);
   p.n := 0;
   for y := p.y downto 1 do begin
      for x := 1 to p.x do begin
         read (f, c);
         if c = '#' then begin
            p.n := p.n + 1;
            p.v[p.n].x := x; p.v[p.n].y := y;
         end;
      end;
      readln (f);
   end;
   close (f);
end;

{ mitu punkti jb ringi sisse }
function pindala (r : longint) : longint;
var x, y, s : longint;
begin
   s := 0; y := r;
   for x := 0 to r do begin
      while sqr (x) + sqr (y) > sqr (r) do
         y := y - 1;
      if x = 0 then
         s := s + (2 * y + 1)
      else
         s := s + 2 * (2 * y + 1);
   end;
   pindala := s;
end;

{ minimaalne ringi raadius, mis keskpunkti (x1, y1) korral kataks (x2, y2) }
function kaugus (x1, y1, x2, y2 : integer) : integer;
var d : integer;
begin
   d := trunc (sqrt (sqr (x2 - x1) + sqr (y2 - y1)));
   while sqr (d) < sqr (x2 - x1) + sqr (y2 - y1) do
      d := d + 1;
   kaugus := d;
end;

{ leiab ringile r parima vimaliku raadiuse, s on pindalad raadiuste kaupa }
procedure leia_raadius (var p : pilt; var s : stat; var r : ring);
var x : stat; i, d : integer; v : longint;
begin
      { ringi sisse jvad valged punktid raadiuste kaupa }
   for i := 0 to maxr do
      x[i] := 0;
   for i := 1 to p.n do begin
      d := kaugus (r.x, r.y, p.v[i].x, p.v[i].y);
      x[d] := x[d] + 1;
   end;
      { leiame raadiuse, mille vigade arv on vhim vimalik }
   v := s[0] + p.n - 2 * x[0];
   r.r := 0; r.v := v;
   for i := 1 to maxr do begin
      v := v + (s[i] - s[i - 1]) - 2 * x[i];
      if v < r.v then begin
         r.r := i; r.v := v;
      end;
   end;
end;

procedure leia_ring (var p : pilt; var r : ring);
var s : stat; i, x, y, d : integer; xs, ys : longint; rr : ring; f : boolean;
begin
      { leiame pindalad raadiuste kaupa, et ei peaks kogu aeg arvutama }
   for i := 0 to maxr do
      s[i] := pindala (i);
      { leiame esimese lhendi }
   xs := 0; ys := 0;
   for i := 1 to p.n do begin
      xs := xs + p.v[i].x; ys := ys + p.v[i].y;
   end;
   r.x := xs div p.n; r.y := ys div p.n;
   leia_raadius (p, s, r);
      { otsime paremaid tema naabrite hulgast }
   d := r.r + 1;
   repeat
      f := false;
      for x := -1 to 1 do
         for y := -1 to 1 do begin
            rr.x := r.x + d * x; rr.y := r.y + d * y;
            leia_raadius (p, s, rr);
            if rr.v < r.v then begin
               r := rr; f := true;
            end;
         end;
      if not f then begin
         d := d div 2;
         if d > 0 then
            f := true;
      end;
   until not f;
end;

procedure tee_valjund (r : ring);
var f : text;
begin
   assign (f, valf); rewrite (f);
   writeln (f, r.x, ' ', r.y, ' ', r.r);
   close (f);
end;

var
   p : pilt;
   r : ring;
begin
   loe_sisend (p);
   leia_ring (p, r);
   tee_valjund (r);
end.
