{ kontroll.pas                                                              }
{ 1999-03-13 programmeerimisolmpiaadi noorema rhma 1. lesande testija    }
{    STATISTILINE SNASTIK                                                  }
{ Ahto Truu                                                                 }

{$I-}

const
   maxn = 1000;                         { maksimaalne snade arv snastikus }
   maxs = 20;                                     { maksimaalne sna pikkus }
   maxr = 80;

type
   sona = string[maxs];
   info = record                                     { sna info snastikus }
      s : sona;                                                      { sna }
      k : integer;                                           { korduste arv }
      f : boolean;
   end;
   sonastik = record                                             { snastik }
      n : integer;                                  { snade arv snastikus }
      a : array [1..maxn] of info;                         { snastiku sisu }
   end;

procedure lisa_sona (var w : sonastik; s : sona);
var i : integer; f : boolean;
begin
   i := 0; f := false;
   while (i < w.n) and not f do begin
      i := i + 1;
      f := w.a[i].s = s;
   end;
   if f then
      w.a[i].k := w.a[i].k + 1
   else begin
      w.n := w.n + 1;
      w.a[w.n].s := s;
      w.a[w.n].k := 1;
      w.a[w.n].f := false;
   end;
end;

procedure loe_sisend (var w : sonastik);
var f : text; c : char; s : string; n, k : integer;
begin
   w.n := 0; s := ''; n := 0; k := 0;

   assign (f, paramstr (1)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   while not eof (f) do begin
      if eoln (f) then
         k := -2;
      read (f, c);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;
      if c in ['A'..'Z'] then begin
         s := s + c;
         if length (s) > maxs then begin
            writeln ('Liiga pikk sna failis ', paramstr (1));
            halt (1);
         end;
         k := k + 1;
         if k > maxr then begin
            writeln ('Liiga pikk rida failis ', paramstr (1));
            halt (1);
         end;
      end else begin
         if s > '' then begin
            n := n + 1;
            if n > maxn then begin
               writeln ('Liiga palju snu failis ', paramstr (1));
               halt (1);
            end;
            lisa_sona (w, s);
         end;
         s := '';
      end;
   end;
   if s > '' then begin
      n := n + 1;
      if n > maxn then begin
         writeln ('Liiga palju snu failis ', paramstr (1));
         halt (1);
      end;
      lisa_sona (w, s);
   end;

   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
end;

procedure leia_sona (var w : sonastik; s : sona; var i : integer);
var f : boolean;
begin
   i := 0; f := false;
   while (i < w.n) and not f do begin
      i := i + 1;
      f := w.a[i].s = s;
   end;
   if not f then
      i := 0;
end;

procedure loe_valjund (var w : sonastik);
var f : text; c : char; s : string; i, k : integer; n : integer;
begin
   assign (f, paramstr (2)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   n := 1;
   while not eof (f) do begin
      s := '';
      repeat
         read (f, c);
         if ioresult <> 0 then begin
            writeln ('Viga faili ', paramstr (2), ' lugemisel');
            halt (1);
         end;
         s := s + c;
      until not (c in ['A'..'Z']);
      delete (s, length (s), 1);
      leia_sona (w, s, i);
      if i = 0 then begin
         writeln ('Tundmatu sna ', s, ' failis ', paramstr (2));
         halt (1);
      end;
      if w.a[i].f then begin
         writeln ('Korduv sna ', s, ' failis ', paramstr (2));
         halt (1);
      end;
      w.a[i].f := true;

      read (f, k);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
      if k <> w.a[i].k then begin
         writeln ('Vale kordus ', k, ' failis ', paramstr (2));
         halt (1);
      end;
      if not seekeoln (f) then begin
         writeln ('Liigsed smbolid faili ', paramstr (2), n, '. rea lpus');
         halt (1);
      end;
      if not eoln (f) then begin
         writeln ('Liigsed thikud faili ', paramstr (2), n, '. rea lpus');
      end;
      n := n + 1;
      readln (f);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
   end;

   if not eof (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (2), ' lpus');
      halt (1);
   end;
   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
end;

var
   w : sonastik;
   i : integer;
begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   loe_sisend (w);
   loe_valjund (w);

   for i := 1 to w.n do
      if not w.a[i].f then begin
         writeln ('Puuduv sna ', w.a[i].s, ' failis ', paramstr (2));
         halt (1);
      end;

   writeln ('Korras');
end.
