{ kontroll.pas                                                              }
{ 1999-03-13 programmeerimisolmpiaadi noorema rhma 2. lesande testija    }
{    KIIP                                                                   }
{ Ahto Truu                                                                 }

{$I-}

const
   maxx = 100;                                    { kiibi maksimaalne laius }
   maxy = 100;                                   { kiibi maksimaalne krgus }
   maxa = 2 * (maxx + maxy);              { maksimaalne jada elementide arv }
   maxd = 4;                            { maksimaalne henduste arv punktil }

type
   solm = record                                          { kiibi vrguslm }
      x, y : integer;                                  { slme koordinaadid }
   end;
   kiip = record                                          { kiibi kirjeldus }
      x, y : integer;                                       { kiibi mtmed }
      o : array [0..maxx, 0..maxy] of integer;             { slmede olekud }
      a, b : solm;                  { puuduva henduse algus- ja lpp-punkt }
      p : integer;                               { lisatava henduse pikkus }
   end;
   jada = record                                       { kiibi slmede hulk }
      n : integer;                                     { slmede arv hulgas }
      s : array [1..maxa] of solm;                                 { slmed }
   end;

procedure loe_sisend (var k : kiip);
var f : text; n, i, x, y, x1, y1, x2, y2 : integer;
begin
   assign (f, paramstr (1)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   read (f, k.x, k.y, n);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
   if (k.x < 1) or (k.x > maxx) or (k.y < 1) or (k.y > maxy) then begin
      writeln ('Lubamatu sisendi maht ', k.x, 'x', k.y, ' failis ', paramstr (1));
      halt (1);
   end;
   if (n < 0) or (n > (k.x + 1) * k.y + (k.y + 1) * k.x) then begin
      writeln ('Lubamatu sisendi maht ', n, ' failis ', paramstr (1));
      halt (1);
   end;
   if not eoln (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (1), ' 1. rea lpus');
      halt (1);
   end;
   readln (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   for x := 0 to k.x do
      for y := 0 to k.y do
         k.o[x, y] := 0;

   for i := 1 to n do begin
      read (f, x1, y1, x2, y2);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;
      if (x1 < 0) or (x1 > k.x) or (y1 < 0) or (y1 > k.y) or
         (x2 < 0) or (x2 > k.x) or (y2 < 0) or (y2 > k.y) or
         not ((x1 = x2) and (abs (y1 - y2) = 1) or (abs (x1 - x2) = 1) and (y1 = y2))
      then begin
         writeln ('Lubamatu sisend ', x1, ' ', y1, ' ', x2, ' ', y2, ' faili ', paramstr (1), ' ', i + 1, '. real');
         halt (1);
      end;

      k.o[x1, y1] := -1;
      k.o[x2, y2] := -1;

      if not eoln (f) then begin
         writeln ('Liigsed smbolid faili ', paramstr (1), i + 1, '. rea lpus');
         halt (1);
      end;
      readln (f);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;
   end;
   read (f, k.a.x, k.a.y, k.b.x, k.b.y);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
   if (k.a.x < 0) or (k.a.x > k.x) or (k.a.y < 0) or (k.a.y > k.y) or
      (k.b.x < 0) or (k.b.x > k.x) or (k.b.y < 0) or (k.b.y > k.y) or
      (k.o[k.a.x, k.a.y] <> 0) or (k.o[k.b.x, k.b.y] <> 0) or
      (k.a.x = k.b.x) and (k.a.y = k.b.y)
   then begin
      writeln ('Lubamatu sisend ', k.a.x, ' ', k.a.y, ' ', k.b.x, ' ', k.b.y, ' faili ', paramstr (1), ' ', n + 2, '. real');
      halt (1);
   end;

   if not eoln (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (1), n + 2, '. rea lpus');
      halt (1);
   end;
   readln (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   if not eof (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (1), ' lpus');
      halt (1);
   end;
   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
end;

{ leiab slme s1 naabri suunas d: 1 - paremal, 2 - leval, 3 - vasakul, 4 - all }
procedure leia_naaber (s1 : solm; d : integer; var s2 : solm);
const
   dx : array [1..maxd] of integer = (1, 0, -1, 0);
   dy : array [1..maxd] of integer = (0, 1, 0, -1);
begin
   s2.x := s1.x + dx[d]; s2.y := s1.y + dy[d];
end;

{ kontrollib, kas slm jb kiibi piiridesse }
function kiibil (var k : kiip; s : solm) : boolean;
begin
   kiibil := not ((s.x < 0) or (s.x > k.x) or (s.y < 0) or (s.y > k.y));
end;

procedure leia_pikkus (var k : kiip);
var a1, a2 : jada; s1, s2 : solm; i, d : integer;
begin
   k.o[k.a.x, k.a.y] := 1;
   a1.n := 1; a1.s[1] := k.a;
   while (k.o[k.b.x, k.b.y] = 0) and (a1.n > 0) do begin
      a2.n := 0;
      for i := 1 to a1.n do begin
         s1 := a1.s[i];
         for d := 1 to maxd do begin
            leia_naaber (s1, d, s2);
            if kiibil (k, s2) then
               if k.o[s2.x, s2.y] = 0 then begin
                  k.o[s2.x, s2.y] := k.o[s1.x, s1.y] + 1;
                  a2.n := a2.n + 1; a2.s[a2.n] := s2;
               end;
         end;
      end;
      for i := 1 to a2.n do
         a1.s[i] := a2.s[i];
      a1.n := a2.n;
   end;
   if k.o[k.b.x, k.b.y] > 0 then
      k.p := k.o[k.b.x, k.b.y] - 1
   else
      k.p := -1;
end;

procedure kontrolli_valjund (var k : kiip);
var f : text; p : integer; s : string;
begin
   assign (f, paramstr (2)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   if k.p = -1 then begin
      readln (f, s);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
      if s <> 'EI SAA' then begin
         writeln ('Vale vastus ', s, ' failis ', paramstr (2));
         halt (1);
      end;
   end else begin
      read (f, p);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
      if not seekeoln (f) then begin
         writeln ('Liigsed smbolid faili ', paramstr (2), ' 1. rea lpus');
         halt (1);
      end;
      if not eoln (f) then begin
         writeln ('Liigsed thikud faili ', paramstr (2), ' 1. rea lpus');
      end;
      readln (f);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
      if p <> k.p then begin
         writeln ('Vale vastus ', p, ' failis ', paramstr (2));
         halt (1);
      end;
   end;

   if not eof (f) then begin
      writeln ('Liigsed smblid faili ', paramstr (2), ' lpus');
      halt (1);
   end;
   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
end;

var
   k : kiip;
begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   loe_sisend (k);
   leia_pikkus (k);

   kontrolli_valjund (k);

   writeln('Korras');
end.
