{ kontroll.pas                                                              }
{ 1999-03-13 programmeerimisolmpiaadi vanema rhma 1. lesande testija     }
{    FAILIDE KOPEERIMINE                                                    }
{ Ahto Truu                                                                 }

{$I-}

const
   maxn = 1000;                                   { maksimaalne failide arv }
   maxf = 12;                                { maksimaalne failinime pikkus }

type
   nimi = string[maxf];
   info = record                                               { faili info }
      n : nimi;                                                      { nimi }
      p : longint;                                                 { pikkus }
   end;
   failid = record                                       { failide nimekiri }
      n : integer;                                            { failide arv }
      f : array [1..maxn] of info;                                 { failid }
      p : longint;
   end;

procedure lisa_fail (var w : failid; t : string; p : longint);
var s : string; i : integer; f : boolean;
begin
   s := '';
   for i := 1 to length (t) do
      if t[i] = '\' then
         s := ''
      else
         s := s + t[i];
   i := 0; f := false;
   while (i < w.n) and not f do begin
      i := i + 1;
      f := (w.f[i].n = s) and (w.f[i].p = p);
   end;
   if not f then begin
      w.n := w.n + 1;
      w.f[w.n].n := s;
      w.f[w.n].p := p;
   end;
end;

function failinimi (t : string) : boolean;
var i, k : integer; p : boolean;
begin
   failinimi := false;
   if t[1] <> ' ' then
      exit;
   delete (t, 1, 1);
   if (length (t) < 4) or (length (t) > 50) then
      exit;
   if not (t[1] in ['A'..'Z']) or (t[2] <> ':') or (t[3] <> '\') then
      exit;
   k := 3; p := false;
   for i := 4 to length(t) do
      case t[i] of
         'A'..'Z', '0'..'9':
            if p then begin
               if i - k > 3 then
                  exit;
            end else 
               if i - k > 8 then
                  exit;
         '\':
            if p then
               exit
            else if i - k < 2 then
               exit
            else
               k := i;
         '.':
            if p then
               exit
            else if i - k < 2 then
               exit
            else begin
               p := true;
               k := i;
            end;
         else
            exit;
      end;
   if k = i then
      exit;
   failinimi := true;
end;

procedure loe_sisend (var w : failid);
var f : text; n, i : integer; p : longint; t : string;
begin
   w.n := 0;
   assign (f, paramstr (1)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' avamisel');
      halt (1);
   end;

   read (f, n);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
   if (n < 1) or (n > maxn) then begin
      writeln ('Lubamatu sisendi maht ', n, ' failis ', paramstr (1));
      halt (1);
   end;
   if not eoln (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (1), ' 1. rea lpus');
      halt (1);
   end;
   readln (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;

   for i := 1 to n do begin
      readln (f, p, t);
      if ioresult <> 0 then begin
         writeln ('Viga faili ', paramstr (1), ' lugemisel');
         halt (1);
      end;
      if (p < 0) or (p > 1000000) then begin
         writeln ('Lubamatu faili pikkus ', p, ' failis ', paramstr (1));
         halt (1);
      end;
      if not failinimi (t) then begin
         writeln ('Lubamatu failinimi ', t, ' failis ', paramstr (1));
         halt (1);
      end;
      lisa_fail (w, t, p);
   end;

   if not eof (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (1), ' lpus');
      halt (1);
   end;
   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      halt (1);
   end;
end;

procedure tee_valjund (var w : failid);
var i : integer;
begin
   w.p := 0;
   for i := 1 to w.n do
      w.p := w.p + w.f[i].p;
end;

procedure loe_valjund (var n : integer; var p : longint);
var f : text;
begin
   assign (f, paramstr (2)); reset (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   read (f, n, p);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
   if not seekeoln (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (2), ' 1. rea lpus');
      halt (1);
   end;
   if not eoln (f) then begin
      writeln ('Liigsed thikud faili ', paramstr (2), ' 1. rea lpus');
   end;
   readln (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if not eof (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (2), ' lpus');
      halt (1);
   end;
   close (f);
   if ioresult <> 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
end;

var
   w : failid;
   n : integer;
   p : longint;
begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   loe_sisend (w);
   tee_valjund (w);

   loe_valjund (n, p);

   if (n <> w.n) or (p <> w.p) then begin
      writeln ('Vale vastus ', n, ' ', p, ' failis ', paramstr (2));
      halt (1);
   end;

   writeln ('Korras');
end.
